{% extends '@KaitekFramework/Backend/module.html.twig' %}
{% trans_default_domain (modulename) %}
{% block begin_javascript_fix %}
<script type="text/javascript">
    {% endblock begin_javascript_fix %}



    {% block begin_javascript %}
    {{ parent() }}
    {{ modulename }}Obj.prototype = {
        storeConfig:{
            //material:{routeName:'MaterialType-getComboValues',table:'material_types',fieldId:'value',fieldDisplay:'concat(value,\'-\',code)'}
            //,materialG:{routeName:'MaterialType-getComboValues',table:'material_types',fieldId:'value',fieldDisplay:'concat(value,\'-\',code)'}
            //,material_unitsUQ:{routeName:'BaseController-getComboValues',table:'material_units',fieldId:'code',fieldDisplay:'code'}
            //,material_unitsPC:{routeName:'BaseController-getComboValues',table:'material_units',fieldId:'code',fieldDisplay:'code'}
        },
        init : function(){
            var t = this;
            {{ modulename }}Obj.superclass.init.call(t);

            const gridConfig = {
                cm: [
                    {header: "{{ 'ProductTree.parent'|trans }}", dataIndex: 'parent', width: 100,filter:'single',alias:'pt',operator:'%.%'}
                    ,{header: "{{ 'ProductTree.materialtype'|trans }}", dataIndex: 'materialtype', width: 50,filter:'single', type:'combo',store:t.extras.material_types,alias:'pt',operator:'='}
                    //,{header: "{{ 'ProductTree.code'|trans }}", dataIndex: 'code', width: 100,filter:'single', alias:'pt',operator:'%.%'}
                    ,{header: "{{ 'ProductTree.name'|trans }}", dataIndex: 'name', width: 150,filter:'single', alias:'pt',operator:'%.%'}
                    ,{header: "{{ 'ProductTree.stockcode'|trans }}", dataIndex: 'stockcode', width: 130,filter:'single', alias:'pt',operator:'%.%'}
                    ,{header: "{{ 'ProductTree.pack'|trans }}", dataIndex: 'pack', width: 130,filter:'single', alias:'pt',operator:'%.%'}
                    ,{header: "{{ 'ProductTree.description'|trans }}", dataIndex: 'description', width: 250,alias:'pt'}
                    ,{header: "{{ 'ProductTree.client'|trans }}", dataIndex: 'client', width: 80,filter:'single', type:'combo',store:t.extras.clients,alias:'pt',operator:'='}
                    ,{header: "{{ 'ProductTree.delivery'|trans }}", dataIndex: 'delivery', width: 60,renderer:mj.renderer.check(),filter:'single', type:'check',alias:'pt'}
                    //{header: "{{ 'ProductTree.isoperationnumberrequired'|trans }}", dataIndex: 'isoperationnumberrequired', width: 60,renderer:mj.renderer.check(),filter:'single', type:'check',alias:'lt'},
                    //{header: "{{ 'ProductTree.closenoemployee'|trans }}", dataIndex: 'closenoemployee', width: 130,renderer:mj.renderer.check(),filter:'single', type:'check',alias:'pt'},
                    //{header: "{{ 'ProductTree.islisted'|trans }}", dataIndex: 'islisted', width: 130,renderer:mj.renderer.check(),filter:'single', type:'check',alias:'pt'}
                ]
            };

            t._setGridConfig(gridConfig);
            t.windowButtons.saveAsCopy=true;
            const formConfig= {
                items: [
                    new mj.form.fieldSet({
                        id : 'f1',
                        title : "{{ 'ProductTree.titleGeneral'|trans }}",
                        width : 930,
                        height : 240,
                        items : [
                            new mj.form.field({
                                dataIndex: 'id',
                                hidden: true
                            }),
                            new mj.form.field({
                                dataIndex: 'version',
                                hidden: true
                            }),
                            new mj.form.combo({
                                title: "{{ 'ProductTree.materialtype'|trans }}",
                                placeHolder: "{{ 'ProductTree.materialtype_placeholder'|trans }}",
                                dataIndex: 'materialtype',
                                sameValueDisplay:false,
                                mode: 'local',
                                clearOnTriggerClick: true,
                                labelWidth : '80px',
                                grid: 's6 m4',
                                width:122,
                                store: t.extras.material_types
                            }),
                            new mj.form.checkBox({
                                title: "{{ 'ProductTree.isdefault'|trans }}",
                                dataIndex: 'isdefault',
                                itemStyle: 'float:left;',
                                labelWidth : '100px',
                                grid: 'none',
                                right: true
                            }),
                            new mj.form.textField({
                                title: "{{ 'ProductTree.parent'|trans }}",
                                dataIndex: 'parent',
                                maxLength: 50,
                                labelWidth : '108px',
                                grid: 's4 m2',
                                width : 200,
                                right:true
                            }),
                            new mj.form.combo({
                                title: "{{ 'ProductTree.client'|trans }}",
                                placeHolder: "{{ 'ProductTree.client_placeholder'|trans }}",
                                dataIndex: 'client',
                                sameValueDisplay:false,
                                mode: 'local',
                                clearOnTriggerClick: true,
                                labelWidth : '80px',
                                grid: 's6 m4',
                                width:122,
                                store: t.extras.clients,
                                right:true
                            }),
                            
                            new mj.form.textField({
                                title: "{{ 'ProductTree.code'|trans }}",
                                dataIndex: 'code',
                                maxLength: 50,
                                labelWidth : '80px',
                                width : 200,
                                grid: 's4 m2'
                            }),
                            new mj.form.numberField({
                                title : "{{ 'ProductTree.number'|trans }}",
                                dataIndex : 'number',
                                labelWidth : '50px',
                                width : 50,
                                right:true
                            }),
                            new mj.form.textField({
                                title: "{{ 'ProductTree.name'|trans }}",
                                dataIndex: 'name',
                                maxLength: 60,
                                labelWidth : '40px',
                                grid: 's12 m6',
                                width : 200,
                                right:true
                            }),
                            new mj.form.textField({
                                title: "{{ 'ProductTree.description'|trans }}",
                                dataIndex: 'description',
                                maxLength: 255,
                                labelWidth : '80px',
                                grid: 's12 m6',
                                width:562
                            }),
                            new mj.form.textField({
                                title: "{{ 'ProductTree.stockcode'|trans }}",
                                dataIndex: 'stockcode',
                                maxLength: 50,
                                labelWidth : '80px',
                                grid: 's12 m6'
                            }),
                            new mj.form.textField({
                                title: "{{ 'ProductTree.stockname'|trans }}",
                                dataIndex: 'stockname',
                                maxLength: 60,
                                labelWidth : '70px',
                                grid: 's12 m6',
                                right:true
                            }),
                            new mj.form.numberField({
                                title : "{{ 'ProductTree.opcounter'|trans }}",
                                dataIndex : 'opcounter',
                                labelWidth : '130px',
                                width : 50,
                                right:true
                            }),
                            new mj.form.numberField({
                                title : "{{ 'ProductTree.empcount'|trans }}",
                                dataIndex : 'empcount',
                                labelWidth : '130px',
                                width : 50,
                                right:true
                            }),
                            new mj.form.numberField({
                                title : "{{ 'ProductTree.tpp'|trans }}",
                                dataIndex : 'tpp',
                                labelWidth : '152px',
                                money : true,
                                suffix : '',
                                decimalPrecision : 4,
                                decimalPrecisionReal : 4,
                                defaultZero : false,
                                width : 50
                            }),
                            new mj.form.numberField({
                                title : "{{ 'ProductTree.quantity'|trans }}",
                                dataIndex : 'quantity',
                                labelWidth : '70px',
                                width : 50,
                                money : true,
                                suffix : '',
                                decimalPrecision : 4,
                                decimalPrecisionReal : 4,
                                defaultZero : false,
                                right:true
                            }),
                            new mj.form.combo({
                                title: "{{ 'ProductTree.unit_quantity'|trans }}",
                                placeHolder: "{{ 'ProductTree.unit_quantity_placeholder'|trans }}",
                                dataIndex: 'unit_quantity',
                                mode: 'local',
                                clearOnTriggerClick: true,
                                labelWidth : '114px',
                                grid: 's6 m4',
                                store: t.extras.material_units,
                                right:true
                            }),
                            new mj.form.numberField({
                                title : "{{ 'ProductTree.notificationtime'|trans }}",
                                dataIndex : 'notificationtime',
                                labelWidth : '129px',
                                width : 50,
                                money : true,
                                suffix : '',
                                defaultZero : false,
                                right:true
                            }),
                            new mj.form.textField({
                                title: "{{ 'ProductTree.pack'|trans }}",
                                dataIndex: 'pack',
                                maxLength: 50,
                                labelWidth : '80px',
                                grid: 's12 m6'
                            }),
                            new mj.form.numberField({
                                title : "{{ 'ProductTree.packcapacity'|trans }}",
                                dataIndex : 'packcapacity',
                                labelWidth : '122px',
                                itemStyle : 'padding-top:5px;',
                                width : 50,
                                right:true
                            }),
                            new mj.form.combo({
                                title: "{{ 'ProductTree.unit_packcapacity'|trans }}",
                                placeHolder: "{{ 'ProductTree.unit_packcapacity'|trans }}",
                                dataIndex: 'unit_packcapacity',
                                mode: 'local',
                                clearOnTriggerClick: true,
                                labelWidth : '130px',
                                grid: 's6 m4',
                                store: t.extras.material_units,
                                right:true
                            }),
                            new mj.form.numberField({
                                title : "{{ 'ProductTree.oporder'|trans }}",
                                dataIndex : 'oporder',
                                labelWidth : '152px',
                                itemStyle : 'padding-top:5px;',
                                width : 50
                            }),
                            new mj.form.numberField({
                                title : "{{ 'ProductTree.productionmultiplier'|trans }}",
                                dataIndex : 'productionmultiplier',
                                labelWidth : '122px',
                                itemStyle : 'padding-top:5px;',
                                width : 50,
                                right: true
                            }),
                            new mj.form.numberField({
                                title : "{{ 'ProductTree.intervalmultiplier'|trans }}",
                                dataIndex : 'intervalmultiplier',
                                labelWidth : '130px',
                                itemStyle : 'padding-top:5px;',
                                width : 50,
                                money : true,
                                suffix : '',
                                decimalPrecision : 2,
                                decimalPrecisionReal : 2,
                                defaultZero : false,
                                right: true
                            }),
                            
                            new mj.form.checkBox({
                                title: "{{ 'ProductTree.delivery'|trans }}",
                                dataIndex: 'delivery',
                                itemStyle: 'float:left;',
                                labelWidth : '100px',
                                grid: 'none',
                                right: true
                            }),
                            
                            new mj.form.dateField({
                                title: "{{ 'ProductTree.start'|trans }}",
                                dataIndex: 'start',
                                labelWidth : '100px',
                                notEmpty: true,
                                grid: 's4 m2'
                            }),
                            new mj.form.dateField({
                                title: "{{ 'ProductTree.finish'|trans }}",
                                dataIndex: 'finish',
                                labelWidth : '70px',
                                grid: 's4 m2',
                                right:true
                            }),
                            new mj.form.numberField({
                                title : "{{ 'ProductTree.lotcount'|trans }}",
                                dataIndex : 'lotcount',
                                labelWidth : '90px',
                                itemStyle : '',
                                width : 50,
                                right:true
                            })
                        ]
                    }),
                    new mj.form.fieldSet({
                        id : 'f2',
                        title : "{{ 'ProductTree.titleMaterialPrepare'|trans }}",
                        width : 930,
                        height : 130,
                        items : [
                            new mj.form.checkBox({
                                title: "{{ 'ProductTree.task'|trans }}",
                                dataIndex: 'task',
                                itemStyle: 'float:left;',
                                labelWidth : '170px',
                                grid: 'none'
                            }),
                            new mj.form.checkBox({
                                title: "{{ 'ProductTree.qualitycontrolrequire'|trans }}",
                                dataIndex: 'qualitycontrolrequire',
                                itemStyle: 'float:left;padding-left: 30px;',
                                labelWidth : '190px',
                                grid: 'none',
                                right: true
                            }),
                            
                            new mj.form.textField({
                                title: "{{ 'ProductTree.locationsource'|trans }}",
                                dataIndex: 'locationsource',
                                maxLength: 50,
                                width : 250,
                                labelWidth : '170px',
                                grid: 's12 m6'
                            }),
                            new mj.form.textField({
                                title: "{{ 'ProductTree.locationdestination'|trans }}",
                                dataIndex: 'locationdestination',
                                maxLength: 50,
                                width : 250,
                                labelWidth : '170px',
                                grid: 's12 m6',
                                right: true
                            }),
                            
                            // new mj.form.textField({
                            //     title: "{{ 'ProductTree.feeder'|trans }}",
                            //     dataIndex: 'feeder',
                            //     maxLength: 5,
                            //     width : 50,
                            //     labelWidth : '152px',
                            //     grid: 's12 m6'
                            // }),
                            // new mj.form.textField({
                            //     title: "{{ 'ProductTree.drainer'|trans }}",
                            //     dataIndex: 'drainer',
                            //     maxLength: 5,
                            //     width : 50,
                            //     labelWidth : '70px',
                            //     grid: 's12 m6',
                            //     right: true
                            // }),
                            new mj.form.textField({
                                title: "{{ 'ProductTree.goodsplanner'|trans }}",
                                dataIndex: 'goodsplanner',
                                maxLength: 255,
                                labelWidth : '170px',
                                width : 250,
                                grid: 's12 m6'
                            }),
                            new mj.form.numberField({
                                title : "{{ 'ProductTree.preptime'|trans }}",
                                dataIndex : 'preptime',
                                labelWidth : '170px',
                                itemStyle : 'padding-top:5px;',
                                width : 50,
                                right: true
                            }),
                            new mj.form.textField({
                                title: "{{ 'ProductTree.carrierfeeder'|trans }}",
                                dataIndex: 'carrierfeeder',
                                maxLength: 255,
                                width : 250,
                                labelWidth : '170px',
                                grid: 's12 m6'
                            }),
                            new mj.form.textField({
                                title: "{{ 'ProductTree.carrierdrainer'|trans }}",
                                dataIndex: 'carrierdrainer',
                                maxLength: 255,
                                width : 250,
                                labelWidth : '170px',
                                grid: 's12 m6',
                                right: true
                            })
                        ]
                    })
                    
                    
                ]
            };
            t._setFormConfig(formConfig);
            t.materialtype = t.forms.main.items[4];
            t.materialtype.view.on('itemclick',function(){
                var arr_val=this.selected[0].value.split('-');
                t.setFormState(arr_val[0]);
            });
        },
        _onButtonAddClick: function() {
            var t=this;
            t.newRecord();
            t.setFormState('');
            t.materialtype.setEnable();
        },
        editSelectedRecord: function() {
            var t=this;
            var selectedRecord = t.getSelectedRecord();
            if (selectedRecord !== false){
                t.editData(selectedRecord);
            }
            var arr_val=t.materialtype.getValue().split('-');
            t.setFormState(arr_val[0]);
            t.materialtype.setDisable();
        },
        setFormState: function(state){
            var t=this;
            var exclude=[];
            switch (state) {
            case 'H':
                {
                exclude=['parent','code','number','description','name','stockcode'
                ,'stockname','quantity','unit_quantity','pack','packcapacity'
                ,'unit_packcapacity','preptime','task','goodsplanner'
                ,'carrierfeeder','carrierdrainer','locationsource','locationdestination'
                ,'isdefault','start','finish'];
                break;
                }

            case 'K':
                {
                exclude=['parent','code','number','description','name','stockcode'
                ,'stockname','pack','packcapacity','unit_packcapacity','preptime'
                ,'task','carrierfeeder','carrierdrainer','locationsource'
                ,'qualitycontrolrequire','locationdestination','isdefault','start','finish'];
                break;
                }

            case 'M':
                {
                exclude=['code','description','name','start','finish'];
                break;
                }
            case 'O':
                {
                exclude=['parent','code','number','client','description','name','tpp'
                ,'notificationtime','opcounter','oporder','productionmultiplier','empcount'
                ,'intervalmultiplier','delivery','start','finish','lotcount'];
                break;
                }
            } 
            for(var i=5;i<t.forms.main.items.length;i++){
                var item = t.forms.main.items[i];
                //console.log(item);
                if(exclude.indexOf(item.dataIndex)===-1){
                    item.el.childNodes[0].style.background='white';
                    if(typeof item.setDisable=='function'){
                        item.setDisable();
                    }
                }else{
                    item.el.childNodes[0].style.background='lightgray';
                    if(typeof item.setEnable=='function'){
                        item.setEnable();
                    }
                }
                
            }
            
        },
        save: function() {
            var t = this,
                _f = this.forms,
                f = this.forms.main;
            t.trigger('beforesave');
            if (f.modulename && typeof Routing !== 'undefined') {
                //if (f.validate()) {
                    var id = f.getValue('id').id;
                    var versionField = f.getField('version');
                    var version = typeof versionField != "undefined" ? f.getValue('version').version : 0;
                    var mode = id ? 'update' : 'add';
                    var routeName = f.modulename + '-' + mode;
                    var route = Routing.getRoute(routeName);
                    var pagerParams = (t.grids && t.grids.main && t.grids.main.pbar) ? {
                        'pg': t.grids.main.pbar.current,
                        'lm': t.grids.main.pbar.limit
                    } : {};
                    var url = Routing.generate(routeName, id ? mj.apply(pagerParams, {
                        'id': id,
                        'v': version
                    }) : pagerParams);
                    var data = f.getValue();
                    data.menuId = t.id;
                    if (route && route.methods && route.methods.length>0 && route.methods[0]) {
                        t.waitMaskShow();
                        t._event='save';
                        $.ajax({
                            url: url,
                            method: "POST",
                            data: JSON.stringify(data),
                            headers: { 
                                "Content-Type": "application/json",
                                "X-HTTP-Method-Override": route.methods[0] 
                            },
                            dataType: 'json',
                            success: function(data, textStatus, jqXHR) {
                                t.reset(_f, data);
                                //t.activateTabGrid();
                                //t.waitMaskHide();
                            },
                            error: function(jqXHR, textStatus, errorThrown) {
                                t.waitMaskHide();
                                mj.message({
                                    title: mj.lng.glb.error,
                                    msg: jqXHR.responseJSON.message + "<br>" + jqXHR.responseJSON.file,
                                    type: "error",
                                    html: true
                                });
                            },
                            complete: function(jqXHR, textStatus) {
                                //t.waitMaskHide();
                            }
                        });
                    }
                //}
            }
	    }
    };
    {% endblock begin_javascript %}



    {% block begin_default_module %}
    {{ parent() }}
    {% endblock begin_default_module %}



    {% block end_default_module %}
    {{ parent() }}
    {% endblock end_default_module %}


    {% block end_javascript %}
    {{ parent() }}
    {% endblock end_javascript %}


    {% block end_javascript_fix %}
</script>
{% endblock end_javascript_fix %}



{% block body %}
    {{ parent() }}
{% endblock body %}
